<?php

namespace app\service;

use app\service\sms\Ali;
use app\service\sms\Tencent;

class Sms
{
    protected $config;
    protected $instance;

    public function __construct($config)
    {
        $this->config = $config;
        $this->init();
    }

    protected function init()
    {
        switch ($this->config['type']) {
            case 'ali':
                $this->instance = new Ali([
                    "accessKeyId" => $this->config['id'],
                    "accessKeySecret" => $this->config['secret'],
                ], $this->config['sign'], $this->config['template_id']);
                break;
            case 'tencent':
                $this->instance = new Tencent([
                    'secretId'=>$this->config['tid'],
                    'secretKey'=>$this->config['key']
                ],$this->config['appid'],$this->config['tencent_sign'], $this->config['tencent_template_id']);
                break;
        }
    }

    public function __call($name, $arguments)
    {
        if (!$this->instance) {
            return false;
        }
        return call_user_func([$this->instance, $name], ...$arguments);
    }
}