<?php
/*
 * @Author: ofearn
 * @Date: 2019/10/18 9:38
 * @Last Modified by: ofearn@qq.com
 */

namespace app\service;

//yimenapp

use app\Db;
use app\lib\File;
use app\lib\Http;

class User
{
    public static function savaUserAvatar($uid, $imgUrl)
    {
        $path = File::getPathByUid($uid);
        Http::getSecond($imgUrl, $uid . '.jpg');
        File::mkdirs(dirname('uc_server/data/avatar/' . $path));
        @copy($uid . '.jpg', 'uc_server/data/avatar/' . $path . '_avatar_small.jpg');
        @copy($uid . '.jpg', 'uc_server/data/avatar/' . $path . '_avatar_middle.jpg');
        @copy($uid . '.jpg', 'uc_server/data/avatar/' . $path . '_avatar_big.jpg');
        unlink($uid . '.jpg');
        return true;
    }

    public static function sendMoney($uid, $money, $type = '2', $lang = 'pay')
    {
        //updatemembercount($uid, [$type => $money], true, '', $uid, tpl_msg($lang), tpl_msg($lang), tpl_msg($lang));
        return true;
        //        //发放充值货币
        //        //获取现有获取现有货币
        //        $userInfo = D('fetch_first', "select * from %t  WHERE uid=%d",
        //            array('common_member_count', $uid));
        //        $nowGold = intval($userInfo[$type]) + $money;
        //        $res = D('update', 'common_member_count', array($type => $nowGold), 'uid=' . $uid);
        //        if ($res) {
        //            notification_add($uid, 'credit', '您好,您充值的积分(金币)已到账,充值数量:' . $money . ',积分(金币)总额:' . $nowGold . '!如果有疑问请联系站内客服.');
        //        }
        //        return $res;
    }

    public static function addUser($username, $password, $email)
    {
        return wp_user_reg($username, $password, $email);
    }

    public static function checkUsername($username)
    {
        $username = sChar(trim($username));
        $usernamelen = get_char_len($username);
        if ($usernamelen < 3) {
            return -1;
        } elseif ($usernamelen > 15) {
            return -2;
        }
        return wp_check_nickname($username) ? 1 : -3;
    }

    public static function getCountByType($type)
    {
        switch ($type) {
            case 'now':
                $date = strtotime(date('Y-m-d', time()));
                break;
            case 'week':
                $w = date('w') ? date('w') : 7;
                $date = mktime(0, 0, 0, date('m'), date('d') - $w + 1, date('Y'));
                break;
            case 'month':
                $date = mktime(0, 0, 0, 1, 1, date('Y'));
                break;
            case 'all':
                $date = 0;
                break;
        }
        return Db::table('yimen_users')->where('create_time', '>=', $date)->count();
    }

    public static function getByUnionid($unionid, $type)
    {
        return Db::table('yimen_users')->where('unionid', $unionid)->where('platform', $type)->first();
    }

    public static function getByOpenid($openid)
    {
        return Db::table('yimen_users')->where('openid', $openid)->first();
    }

    public static function getByUsername($username)
    {
        return Db::table('yimen_users')->where('username', $username)->first();
    }

    public static function upById($id, $data)
    {
        return Db::table('yimen_users')->where('id', $id)->update($data);
    }

    public static function upByOpenid($token, $data)
    {
        return Db::table('yimen_users')->where('openid', $token)->update($data);
    }

    public static function add($data)
    {
        return Db::table('yimen_users')->insert($data);
    }

    public static function getCount()
    {
        return Db::table('yimen_users')->count();
    }

    public static function getList($page, $size)
    {
        $start = ($page - 1) * $size;
        return Db::table('yimen_users')->orderByDesc('create_time')->skip($start)->take($size)->get()->toArray();
    }
    
    public static function getPushMemberCount()
    {
        return Db::table('yimen_push_device')->groupBy(['uid'])->count();
    }

    public static function getPushMemberList($page, $size)
    {
        $start = ($page - 1) * $size;
        return Db::table('yimen_push_device')->orderByDesc('yimen_push_device.create_time')
            ->groupBy(['yimen_push_device.uid'])->leftJoin('common_member', 'yimen_push_device.uid', '=', 'common_member.uid')->skip($start)->take($size)
            ->select('yimen_push_device.*', 'common_member.username')->get()->toArray();
    }

    public static function getPushMemberDeviceCount($uid)
    {
        return Db::table('yimen_push_device')->where('uid', $uid)->count();
    }

    public static function getPushMemberDevices($uid)
    {
        return Db::table('yimen_push_device')->where('uid', $uid)->get()->toArray();
    }

    public static function getPushMemberTags($uid)
    {
        return Db::table('yimen_push_member_tag')->where('uid', $uid)->get()->toArray();
    }
}
