<?php
/*
 * @Author: ofearn
 * @Date: 2020/4/14 9:36
 * @Last Modified by: ofearn@qq.com
 */

function wp_is_admins()
{
    $user = get_userdata(wp_get_uid());
    if (!empty($user->roles) && in_array('administrator', $user->roles))
        return 1;  // 是管理员
    else
        return 0;  // 非管理员
}

function wp_get_uid()
{
    global $current_user;
    wp_get_current_user();
    return $current_user->ID;
}

function wp_get_wp_pathinfo()
{
    $path = explode('?', $_SERVER['REQUEST_URI']);
    $path = ltrim($path[0], '/');
    $path = ltrim($path, 'ym');
    $path = ltrim($path, '/');
    return $path;
}

function showmessage($msg, $url)
{
    echo $msg;
}

function tpl_msg($name)
{
    return $name;
}

function wp_check_nickname($nickname)
{
    $user_query = new WP_User_Query(array(
        'meta_key' => 'nickname',
        'meta_value' => $nickname,
        'number' => 1
    ));
    $count = $user_query->get_total();
    if ($count) {
        return true;
    }
    return false;
}

function wp_update_username($uid, $username)
{
    global $wpdb;
    if ($wpdb->query("UPDATE $wpdb->users SET user_login = '$username' WHERE ID=$uid;")) {
        if (wp_check_nickname($username)) { //判断用户名对应的昵称是否存在，如果不存在则自动把昵称也改为跟用户名一样的
            $username .= rand(1000, 9999);
        }
        update_user_meta($uid, 'nickname', $username);
        return true;
    }
    return false;
}

function wp_uid_Login($uid)
{
    wp_set_auth_cookie($uid, true);
}

function wp_user_login($username, $password)
{
    $data = [
        'user_login' => $username,
        'user_password' => $password,
        'remember' => true
    ];
    $verify = wp_signon($data, false);
    if (is_wp_error($verify)) {
        return false;
    }
    return true;
}

function wp_user_reg($username, $password, $email)
{
    $rand_name = rand(100000000, 999999999);
    $uid = wp_create_user($rand_name, $password, $email);
    if (!$uid) {
        return 0;
    }
    wp_update_username($uid, $username);
    update_user_meta($uid, 'perfect', 1);
    update_user_meta($uid, 'avatar_type', 'default');
    update_user_meta($uid, 'reg_type', 'email');
    return $uid;
}

function getSetting($group)
{
    global $wpdb;
    $table_name = $wpdb->prefix . 'yimen_settings';
    $settings = $wpdb->get_results("SELECT * FROM $table_name where `group`='$group'");
    $setting = [];
    foreach ($settings as $v) {
        $setting[$v->name] = $v->value;
    }
    return $setting;
}

function dstrpos($string, $arr, $returnvalue = false)
{
    if (empty($string)) return false;
    foreach ((array)$arr as $v) {
        if (strpos($string, $v) !== false) {
            $return = $returnvalue ? $v : true;
            return $return;
        }
    }
    return false;
}

function is_mobile()
{
    $mobile = array();
    static $mobilebrowser_list = array(
        'iphone', 'android', 'phone', 'mobile', 'wap', 'netfront', 'java', 'opera mobi', 'opera mini',
        'ucweb', 'windows ce', 'symbian', 'series', 'webos', 'sony', 'blackberry', 'dopod', 'nokia', 'samsung',
        'palmsource', 'xda', 'pieplus', 'meizu', 'midp', 'cldc', 'motorola', 'foma', 'docomo', 'up.browser',
        'up.link', 'blazer', 'helio', 'hosin', 'huawei', 'novarra', 'coolpad', 'webos', 'techfaith', 'palmsource',
        'alcatel', 'amoi', 'ktouch', 'nexian', 'ericsson', 'philips', 'sagem', 'wellcom', 'bunjalloo', 'maui', 'smartphone',
        'iemobile', 'spice', 'bird', 'zte-', 'longcos', 'pantech', 'gionee', 'portalmmm', 'jig browser', 'hiptop',
        'benq', 'haier', '^lct', '320x320', '240x320', '176x220'
    );
    $pad_list = array('pad', 'gt-p1000');

    $useragent = strtolower($_SERVER['HTTP_USER_AGENT']);

    if (dstrpos($useragent, $pad_list)) {
        return false; //当前为使用PAD用户，返回false
    }
    if (($v = dstrpos($useragent, $mobilebrowser_list, true))) {
        return true; //手机端访问，返回true
    }
    $brower = array('mozilla', 'chrome', 'safari', 'opera', 'm3gate', 'winwap', 'openwave', 'myop');
    if (dstrpos($useragent, $brower)) return false; //PC浏览器访问，返回false
}

function runsql($db, $sqls)
{
    foreach ($sqls as $sql) {
        $db->query($sql);
    }
}

function create_yimen_table()
{
    require_once(ABSPATH . "wp-admin/includes/upgrade.php");
    global $wpdb;
    $table_name = $wpdb->prefix . "yimen_goods";
    if ($wpdb->get_var("show tables like $table_name") != $table_name) {
        $sql = "CREATE TABLE " . $table_name . " (
            `id` int(10) NOT NULL AUTO_INCREMENT,
            `name` varchar(255)  NOT NULL,
            `amount` decimal(8, 2) NOT NULL,
            `count` int(11) NOT NULL,
            `type` tinyint(3) DEFAULT '1',
            `ios` varchar(32) DEFAULT NULL,
            PRIMARY KEY (`id`) USING BTREE
          ) ENGINE = InnoDB ROW_FORMAT = Compact;";
        dbDelta($sql);
    }
    $table_name = $wpdb->prefix . "yimen_orders";
    if ($wpdb->get_var("show tables like $table_name") != $table_name) {
        $sql = "CREATE TABLE " . $table_name . " (
            `id` int(11) NOT NULL AUTO_INCREMENT,
            `uid` int(10) NOT NULL,
            `order_id` varchar(128) NOT NULL,
            `trade_id` varchar(128) NOT NULL,
            `order_name` varchar(64)NOT NULL,
            `goods_id` int(10) NULL DEFAULT NULL,
            `amount` decimal(8, 2) NOT NULL,
            `type` varchar(32) NOT NULL,
            `state` int(3) NOT NULL,
            `create_time` varchar(32) NOT NULL,
            `update_time` varchar(32) NULL DEFAULT NULL,
            PRIMARY KEY (`id`) USING BTREE,
            KEY `order_id` (`order_id`),
            KEY `create_time` (`create_time`)
          ) ENGINE = MyISAM ROW_FORMAT = Dynamic;";
        //引用wordpress的内置方法库
        dbDelta($sql);
    }
    $table_name = $wpdb->prefix . "yimen_settings";
    if ($wpdb->get_var("show tables like $table_name") != $table_name) {
        $sql = "CREATE TABLE " . $table_name . " (
            `id` int(11) NOT NULL AUTO_INCREMENT,
            `name` varchar(32) NOT NULL,
            `value` text NOT NULL,
            `group` varchar(32) NOT NULL,
            `tip` varchar(128)  NOT NULL,
            PRIMARY KEY (`id`) USING BTREE,
            KEY `name` (`name`)
          ) ENGINE = MyISAM ROW_FORMAT = Dynamic";
        dbDelta($sql);
    }
    $table_name = $wpdb->prefix . "yimen_users";
    if ($wpdb->get_var("show tables like $table_name") != $table_name) {
        $sql = "CREATE TABLE " . $table_name . " (
            `id` int(11) NOT NULL AUTO_INCREMENT,
            `uid` int(10) NULL DEFAULT NULL,
            `username` varchar(16) NOT NULL,
            `password` varchar(32) NOT NULL,
            `openid` varchar(64) NOT NULL,
            `unionid` varchar(64) NOT NULL,
            `nick` varchar(255) NOT NULL,
            `avatar` varchar(1000) NOT NULL,
            `email` varchar(32) NOT NULL,
            `platform` varchar(16) NOT NULL,
            `state` int(2) NOT NULL DEFAULT 1,
            `create_time` varchar(32) NOT NULL,
            `update_time` varchar(32) NULL DEFAULT NULL,
            PRIMARY KEY (`id`) USING BTREE,
            KEY `openid` (`openid`),
            KEY `unionid` (`unionid`)
          ) ENGINE = MyISAM  ROW_FORMAT = Dynamic";
        dbDelta($sql);
    }
    $table_name = $wpdb->prefix . "yimen_apps";
    if ($wpdb->get_var("show tables like $table_name") != $table_name) {
        $sql = "CREATE TABLE " . $table_name . " (
            `id` int(8) NOT NULL AUTO_INCREMENT,
            `appid` int(10) DEFAULT NULL,
            `secret` varchar(64) DEFAULT NULL,
            `name` varchar(64) DEFAULT NULL,
            `url` varchar(64) DEFAULT NULL,
            `url_pc` varchar(64) DEFAULT NULL,
            `icon` varchar(255) DEFAULT NULL,
            `state` tinyint(3) DEFAULT '1',
            PRIMARY KEY (`id`)
          ) ENGINE=MyISAM;";
        dbDelta($sql);
    }
    $table_name = $wpdb->prefix . "yimen_scan";
    if ($wpdb->get_var("show tables like $table_name") != $table_name) {
        $sql = "CREATE TABLE " . $table_name . " (
            `id` int(8) NOT NULL AUTO_INCREMENT,
            `uid` int(8) NOT NULL DEFAULT '0',
            `code` varchar(255) NOT NULL,
            `state` tinyint(3) NOT NULL DEFAULT '0',
            `create_time` varchar(32) NOT NULL,
            `update_time` varchar(32) DEFAULT NULL,
            PRIMARY KEY (`id`)
          ) ENGINE = MyISAM;";
        dbDelta($sql);
    }
    $table_name = $wpdb->prefix . "yimen_push_device";
    if ($wpdb->get_var("show tables like $table_name") != $table_name) {
        $sql = "CREATE TABLE " . $table_name . " (
            `id` int(10) NOT NULL AUTO_INCREMENT,
            `uid` int(10) NULL DEFAULT NULL ,
            `client_id` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL ,
            `android` tinyint(3) NULL DEFAULT NULL,
            `model` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
            `status` tinyint(3) NULL DEFAULT NULL,
            `create_time` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
            `update_time` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
            PRIMARY KEY (`id`) USING BTREE
            ) ENGINE = InnoDB  CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMI";
        dbDelta($sql);
    }
    $table_name = $wpdb->prefix . "yimen_push_member_tag";
    if ($wpdb->get_var("show tables like $table_name") != $table_name) {
        $sql = "CREATE TABLE " . $table_name . " (
            `id` int(10) NOT NULL AUTO_INCREMENT,
            `uid` int(10) NULL DEFAULT NULL ,
            `tag_id` int(10) NULL DEFAULT NULL ,
            `status` tinyint(3) NULL DEFAULT NULL,
            `create_time` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
            `update_time` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
            PRIMARY KEY (`id`) USING BTREE
            ) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;";
        dbDelta($sql);
    }
    $table_name = $wpdb->prefix . "yimen_yimen_push_record";
    if ($wpdb->get_var("show tables like $table_name") != $table_name) {
        $sql = "CREATE TABLE " . $table_name . " (
            `id` int(11) NOT NULL AUTO_INCREMENT,
            `title` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
            `content` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL ,
            `type` tinyint(3) NOT NULL ,
            `target` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
            `extend` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL ,
            `schedule` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL ,
            `record` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
            `status` tinyint(3) NOT NULL ,
            `create_time` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
            `update_time` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
            PRIMARY KEY (`id`) USING BTREE
          ) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;";
        dbDelta($sql);
    }
    
    $table_name = $wpdb->prefix . "yimen_yimen_push_tag";
    if ($wpdb->get_var("show tables like $table_name") != $table_name) {
        $sql = "CREATE TABLE " . $table_name . " (
            `id` int(10) NOT NULL AUTO_INCREMENT,
            `name` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
            `comment` varchar(1000) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
            `style` varchar(1000) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
            `level` int(10) NULL DEFAULT NULL,
            `create_time` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
            `update_time` varchar(16) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
            PRIMARY KEY (`id`) USING BTREE
          ) ENGINE = InnoDB  CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = DYNAMIC;";
        dbDelta($sql);
    }
    
    $table_name = $wpdb->prefix . "yimen_sms_code";
    if ($wpdb->get_var("show tables like $table_name") != $table_name) {
        $sql = "CREATE TABLE " . $table_name . " (
            `id` int(10) NOT NULL AUTO_INCREMENT,
            `mobile` varchar(16) NOT NULL,
            `code` varchar(16) NOT NULL,
            `status` tinyint(3) NOT NULL DEFAULT '0',
            `ip` varchar(32) NOT NULL,
            `create_time` varchar(32) NOT NULL,
            `update_time` varchar(32) NOT NULL,
            PRIMARY KEY (`id`)
            ) ENGINE=InnoDB DEFAULT CHARSET=utf8;";
        dbDelta($sql);
    }
    
    $content = file_get_contents(__DIR__ . '/add.sql');
    $content = str_replace('{pre}', $wpdb->prefix, $content);
    $add = explode("\r\n", $content);
    runsql($wpdb, $add);
}

function add_m()
{
    add_menu_page(
        '一门app管理',
        '一门app管理',
        'manage_options',
        '../wp-content/plugins/yimen_app/admin.php',
        null,
        '/wp-content/plugins/yimen_app/static/app.png',
        0
    );
}
