<?php


namespace app\yimen\push;


class Push extends Base
{
    protected $key;
    protected $secret;
    protected $uniacid;
    protected $app_list;
    /**
     * @var Auth
     */
    protected $auth_client;

    public function getAppInfo()
    {
        if (isset($this->app_list[$this->uniacid])) {
            return $this->app_list[$this->uniacid];
        }
        $ret = $this->auth_client->getAppInfoByUniacid($this->uniacid);
        if (!isset($ret['data']['app_customer']) || $ret['data']['app_customer'] == null) {
            return false;
        }
        $this->app_list[$this->uniacid] = $ret['data']['app_customer'];
        return $this->app_list[$this->uniacid];
    }


    public function sendNotification($app_id,$title, $content, $url, $type, $list, $android, $ios,$a,$i)
    {
        //组装消息
        if ($android['enabled'] == 'false' && $ios['enabled'] == 'false') {
            return [
                'status' => false,
                'message' => ['path']
            ];
        }
        $data = [
            'title' => $title,
            'content' => $content,
            'url' => $url,
            'app_id' => $app_id
        ];
        if ($type != 1) {
            $data['target']['client_ids'] = $list;
        }
        if($a==1){
            $data['android'] = $android;
        }
        if($i==1) {
            $data['ios'] = $ios;
        }
        $ret = $this->sendPost('Push/v1/SendNotification', $data);
        if ($ret['code'] == 1) {
            return [
                'status' => false,
                'message' => [$ret['message']]
            ];
        }
        $success = true;
        $message = [];
        if ($ret['data']['android'] != null) {
            $content = json_decode($ret['data']['android']['content'], true);
            if ($content['code'] != 0) {
                $success = false;
            }
            $message[] = $content;
        }
        if ($ret['data']['ios'] != null) {
            $content = json_decode($ret['data']['ios']['content'], true);
            if ($content['code'] != 0) {
                $success = false;
            }
            $message[] = $content;
        }
        return [
            'status' => $success,
            'message' => $message
        ];
    }
}